unit uPaint2Obj;

{$MODE Delphi}

interface

uses
  LCLIntf,  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,StdCtrls,upaint2ObjBase,tools;

type
  TRectEck = class(TPaint2BasesObj)
  private
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean);override;
  end;

  TKreis = class(TPaint2BasesObj)
  private
    fRadios:Integer;
    function GetRadios:Integer;
    procedure SetRadios(value:Integer);
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean);override;

  procedure Save(Stringlist:TStringList;stream:TStream);
  procedure load(Stringlist:TStringList;stream:TStream);
  published
    property Radios:Integer read GetRadios write SetRadios;
  end;

  TLine = class(TPaint2BasesObj)
  private
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean);override;
  end;

  Tbg = class(TPaint2BasesObj)
  private
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean);override;
  end;
  
  troundrec = class(TPaint2BasesObj)
  private
    frx,fry:Integer;
    procedure SetR(index,value:Integer);
    function GetR(index:Integer):Integer;
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean);override;
    procedure Save(Stringlist:TStringList;stream:TStream);
    procedure Load(Stringlist:TStringList;stream:TStream);

  published
    property Rx:Integer index  1 read getr write setR;
    property Ry:Integer index  2 read getr write setR;

  end;

implementation


constructor TRectEck.Create(value:TBitMap);
begin
  Name:='Rechteck';
//  fpen:=TPen.Create; fBrush:=TBrush.Create;
  inherited Create(Value);
end;

procedure TRectEck.Draw(buffer:TBitMap;fissel:Boolean);
begin
  inherited;
  buffer.Canvas.Rectangle(position.x,position.y,size.x,size.y);
//  if isMoved = true then begin
//    WriteLn('Draw');
//      buffer.Canvas.Brush.Color:=clBlack;
//    buffer.Canvas.Rectangle(changepos.x,changepos.y,ChangeSize.x,ChangeSize.y);
//  end;

  Buffer.Canvas.Pen:=oldpen;
  Buffer.Canvas.Brush:=oldbrush;
end;

constructor TKreis.Create(value:TBitMap);
begin
  Name:='Kreis';
//  fpen:=TPen.Create; fBrush:=TBrush.Create;
  inherited Create(Value);
end;

procedure TKreis.Draw(buffer:TBitMap;fissel:Boolean);
begin
  inherited;
  buffer.Canvas.Ellipse(position.x,position.y,size.x,size.y);

  Buffer.Canvas.Pen:=oldpen;

  Buffer.Canvas.Brush:=oldbrush;
end;

function TKreis.GetRadios:Integer;
begin
  result:=fRadios;
end;

procedure TKreis.SetRadios(value:Integer);
begin
  fRadios:=Value;
end;

procedure TKreis.Save(Stringlist:TStringList;stream:TStream);
begin
  inherited;
  if Stringlist <> NIL then begin
    Stringlist.add('kreis.radios = ' + IntTostr(Radios));
  end;

  if stream <> NIL then begin
  end;

end;

procedure TKreis.load(Stringlist:TStringList;stream:TStream);
var
  index:Integer;
  str:String;
begin
  inherited;
  if Stringlist <> NIL then begin
    index:=GetStringListIndex('kreis.radios',StringList);
    if index > -1 then begin
      Radios:=StrToInt(GetToken(Stringlist[index],'=',2));
    end;
  end;

  if stream <> NIL then begin
  end;
end;

constructor TLine.Create(value:TBitMap);
begin
  Name:='Line';
//  fpen:=TPen.Create; fBrush:=TBrush.Create;
  inherited Create(Value);

end;

procedure TLine.Draw(buffer:TBitMap;fissel:Boolean);
begin
  inherited;
  buffer.Canvas.moveTo(position.x,position.y);
  buffer.Canvas.LineTo(size.x,size.y);
//  if fissel = true then
    
  Buffer.Canvas.Pen:=oldpen;
  Buffer.Canvas.Brush:=oldbrush;

end;

constructor Tbg.Create(value:TBitMap);
begin
  Name:='Backgrund';
//  fpen:=TPen.Create; fBrush:=TBrush.Create;
  fest:=True;
  inherited Create(Value);
end;

procedure Tbg.Draw(buffer:TBitMap;fissel:Boolean);
begin
  inherited;
  buffer.Canvas.Rectangle(position.x,position.y,size.x,size.y);
  Buffer.Canvas.Pen:=oldpen;Buffer.Canvas.Brush:=oldbrush;
end;

constructor troundrec.Create(value:TBitMap);
begin
  Name:='Abgerundesviereck';
  fest:=False;
  frx:=20; fry:=20;
  inherited Create(Value);
end;

procedure troundrec.Draw(var buffer:TBitMap;fissel:Boolean);
begin
  inherited;
  buffer.Canvas.RoundRect(position.x,position.y,size.x,size.y,frx,fry)
end;

procedure troundrec.SetR(index,value:Integer);
begin
  if index = 1 then frx:=value;
  if index = 2 then fry:=value;
end;

function troundrec.GetR(index:Integer):Integer;
begin
  if index = 1 then result:=frx;
  if index = 2 then result:=fry;

end;

procedure troundrec.Save(Stringlist:TStringList;stream:TStream);
begin
  inherited;
  if Stringlist <> NIL then begin
    Stringlist.add('roundrec.r = ' + IntTostr(frx) + ',' + intTostr(fry));
  end;

  if stream <> NIL then begin
  end;
end;

procedure troundrec.load(Stringlist:TStringList;stream:TStream);
var
  index:Integer;
  str:String;
begin
  inherited;
  if Stringlist <> NIL then begin
    index:=GetStringListIndex('roundrec.r',StringList);
    if index > -1 then begin
      str:=GetToken(Stringlist[index],'=',2);
      rx:=StrToInt(GetToken(str,',',1));
      ry:=StrToInt(GetToken(str,',',2));
    end;

  end;

  if stream <> NIL then begin
  end;
end;

end.
