unit uListe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Graphics,Contnrs,uPaint2Obj,upaint2ObjBase,
  StdCtrls,LCLIntf,RTTIGrids,dialogs,uextras,uPaint2Object,inifiles,tools;
  
const
  nul1 = 0;
  Backgrund      = -2;
  None           = -1;
  alt_Line       = 0;
  alt_Dreieck    = 1;
  alt_Vireck     = 2;
  alt_kreis      = 3;
  alt_Text       = 4;
  alt_Poligon    = 5;
  alt_agr        = 6; // abgerundes Reckeck

  Neu_Line       = 30;
  Neu_Dreieck    = 31;
  Neu_Vieck      = 32;
  Neu_Kreis      = 33;
  Neu_Text       = 34;
  Neu_Poligon    = 35;
  Neu_agr        = 36; // abgerundes Recheck

  Allgemein_cf   = 60; // Farbfller;
  Allgemein_cp   = 61; // Farbfinder

type

  { TmyList }


  TmyList = class
  private
    fBuffer:TBitmap;
    fselectObject:TPaint2BasesObj;
    fVt:TTIPropertyGrid;
    function GetSelect: TPaint2BasesObj;
    procedure SetSelect(const AValue: TPaint2BasesObj);
    procedure SetSelectObject(const AValue: TPaint2BasesObj);
  public
    liste:TObjectList;
    usrListBox:TListBox;
    
    itemindex:integer;
    bg:Tbg;
    property selobject:TPaint2BasesObj read GetSelect write SetSelectObject;

    function GetItemIndex(x,y:Integer;Obj:TObjectList;state:TShiftState):Integer;

    function GetPaint2Obj(index:Integer):TPaint2BasesObj;
    function DeleteObject(index:integer):Integer;
    function GetSelObject:Integer;
    function AddObj(toolindex:Integer):TPaint2Object;

    procedure SetVisibleObj(index:Integer; value:Boolean);
    procedure SetBrush(Index:Integer; value:TBrush);
    procedure SetPen(Index:Integer; value:TPen);
    constructor Create(oi:TTIPropertyGrid;buffer:tBitmap;pBg:Tbg);
    function GetName(objtyp:Integer):Integer;
    procedure Clear;
    procedure SetSelObj(value:Boolean);
    procedure UpdatetOI;
    procedure SaveToFile(FileName:TFileName);

    procedure LoadFromFile(FileName:TFileName);
  published
  end;


implementation

{ TmyList }
uses upaint2main;


function GetLineClickA(x1,y1,x2,y2,x3,y3:Integer):Boolean;
var
// Gegeben
  A: TPoint; // Punkt der Geraden
  B: TPoint; // Punkt der Geraden
  P: TPoint; // Punkt des Mausklicks
// errechnete Werte
  g: TPoint; // Richtungsvektor
  n: TPoint; // Normalvektor
  d: Integer; // d = a*x + b*y

  HNF: Double;

begin
  a.x:=x1; a.y:=y1;
  b.x:=x2; b.y:=y2;
  p.x:=x3; p.y:=y3;
  
  g := Point(B.X - A.X, B.Y - A.Y);
  n := Point(g.Y, -g.X);
  d := n.X * A.X + n.Y * A.Y;

  HNF := Abs((n.X * P.X + n.Y * P.Y - d) / Sqrt(n.X * n.X + n.Y * n.Y));

  // hier Wert anpassen

  if HNF < 5 then
    result:=True
  else
    result:=false;
end;

function GetLineClick(x1,y1,x2,y2,x3,y3:Integer):Boolean;
var
  dxa,dya,dxb,dyb,x,y,x4,y4,dist:Integer;
begin
  dxa:=x2-x1;
  dya:=y2-y1;

  x4:=x3+(y2-y1);
  y4:=y3-(x2-x1);

  dxb:=x4-x3;
  dyb:=y4-y3;

  x:=round(((y3-y1)*dxa*dxb+x1*dya*dxb-x3*dyb*dxa)/(dya*dxb-dyb*dxa));
  if abs(dxa)>abs(dxb) then
    y:=round(((x-x1)*dya+y1*dxa)/dxa)
  else
    y:=round(((x-x3)*dyb+y3*dxb)/dxb);
  dist:=round(sqrt(sqr(x3-x)+sqr(y3-y)));
  
  if not((((x<=x1)and(x>=x2))or((x>=x1)and(x<=x2))) and (((y<=y1)and(y>=y2))or((y>=y1)and(y<=y2)))) then
    result:=false
  else
    result:=true;
end;

procedure TmyList.SaveToFile(FileName:TFileName);
var
  i:Integer;
  Daten:TStringList;
begin
  Daten:=TStringList.Create;
  bg.Save(Daten,nil);
  for i:=0 to liste.Count-1 do begin
    TPaint2BasesObj(liste[i]).Save(Daten,nil);
  end;
  Daten.SaveToFile(FileName);
//  Showmessage(Daten.text);
end;

procedure TmyList.LoadFromFile(FileName:TFileName);
var
  inifile:inifiles.TIniFile;
  i,typ:Integer;
  Daten,Daten2:TStringList;
  op:TPaint2BasesObj;
  str:String;
begin
  if FileExists(Filename) = True then begin
    typ:=-1;
    iniFile:=TIniFile.Create(Filename);
    Daten:=TStringList.Create;
    inifile.ReadSections(Daten);
    daten2:=TStringlist.Create;
    for i:=0 to Daten.Count-1 do begin
      inifile.ReadSectionRaw(Daten[i],daten2);
      str:=GetToken(daten2.Strings[3],'=',2);
      if str <> '-2' then
        typ:=StrToInt(str)
      else
        typ:=-2;

      if typ <> -2 then begin
        upaint2main.paint2.AddObj(typ,20,20,20,20);
//        AddObj(typ);
        selobject.load(Daten2,nil);

      end
      else begin
        bg.load(Daten2,nil)
      end;

    end;
  end;

end;

function TmyList.GetItemIndex(x,y:Integer;Obj:TObjectList;state:TShiftState):Integer;
var
  i,pIndex:Integer;
  r:TRect;
  Region:     THandle;
begin
  pIndex:=-1;

  for i:=0 to obj.count-1 do begin
    with TPaint2BasesObj(liste.items[i]) do begin
      if obj.Items[i] is TLine = false then begin
        r.left:=position.x; r.top:=position.y; r.Right:=size.x;r.Bottom:=size.y;
        if PtInRect(r,point(x,y)) = true then
          pindex:=i;
      end
      else begin
      if (GetLineClickA(position.x,position.y,size.x,size.y,x,y) = true) then
         pindex:=i;
      end;
    end;
  end;
  if pindex > -1 then begin
    selobject:=TPaint2BasesObj(liste.items[pindex]);
    itemindex:=pIndex;
  end;
  writeLn(IntTostr(Pindex));

  result:=Pindex;
  if pindex > -1 then begin
    if ssshift in state then
    TPaint2BasesObj(liste.items[pindex]).Sel:=True;
  end
  else begin
    SetSelObj(false);
    selobject:=bg;
  end;
  Region:=0;
//  Region
end;

function TmyList.GetName(objtyp:Integer):Integer;
var
  i,z:Integer;
begin
  z:=-1;
  if objtyp < 80 then begin
    for i:=0 to liste.count -1 do begin
      if TPaint2BasesObj(liste.items[i]).Typ = objtyp then
        inc(z)
    end;
  end
  else begin
    for i:=0 to usrListBox.items.count -1 do begin
      if usrListBox.Items.Objects[i] is tImageListB then
        inc(z)
    end;

  end;
  
  result:=z+1;
end; // GetName

function TmyList.GetSelect: TPaint2BasesObj;
begin
  result:=fselectObject;
end;

procedure TmyList.SetSelect(const AValue: TPaint2BasesObj);
begin
  fselectObject:=AValue;
end;

function TmyList.GetPaint2Obj(index: Integer): TPaint2BasesObj;
begin
  if index > -1 then
    result:=TPaint2BasesObj(liste.items[index])
  else
    result:=nil;
end;

procedure TmyList.SetSelectObject(const AValue: TPaint2BasesObj);
begin
  fselectObject:=AValue;
  if AValue <> NIL then begin
    if fVt <> NIL then
    fVt.TIObject:=Avalue;
      writeLn('608246608246');
  end
  else begin
    if Bg <> NIL then begin
      writeLn('Hallo, du test');
    if fVt <> NIL then
      fVt.TIObject:=Bg;
    end;
  end;
end;

function TmyList.DeleteObject(index: integer): Integer;
var
  i:Integer;
begin
  if index = -2 then begin
    for i:=liste.Count-1 downto 0 do begin
      if TPaint2BasesObj(liste.Items[i]).Sel = true then
        liste.Delete(i);
    end;
  end;
end; // DeleteObject

function TmyList.GetSelObject: Integer;
begin
  result:=1;
end; // GetSelObject

function TmyList.AddObj(toolindex:Integer): TPaint2Object;
var
  paint2obj:TPaint2Object;
begin
  fBuffer.Canvas.Brush.color:=clBlue;
  paint2obj:=nil;
  if toolindex = alt_Vireck then paint2obj:=TRectEck.Create(fBuffer);
  if toolindex = alt_kreis then paint2obj:=TKreis.Create(fBuffer);
  if toolindex = alt_Line then  paint2obj:=TLine.Create(fBuffer);

   if toolindex = alt_agr then  paint2obj:=troundrec.Create(fBuffer);

  if toolindex = Extras_ImageListB then begin
    paint2obj:=tImageListB.Create;
  end;
  

  if toolindex < 80 then begin
    if paint2obj <> NIL then begin
      liste.Add(paint2obj);
      result:=TPaint2Object(liste[liste.Count-1]);
      selobject:=TPaint2BasesObj(liste[liste.Count-1]);
     itemindex:=liste.Count-1;
   end
    else
      result:=nil;
  end
  else begin

    usrListBox.Items.AddObject(paint2obj.Name,tImageListB(paint2obj));
    result:=TPaint2Object(usrListBox.Items.Objects[usrListBox.items.Count-1]);

  end;
end; // AddObj

procedure TmyList.SetVisibleObj(index: Integer; value: Boolean);
begin

end; // SetVisibleObj

procedure TmyList.SetBrush(Index: Integer; value: TBrush);
begin

end; // SetBrush

procedure TmyList.SetPen(Index: Integer; value: TPen);
begin

end; // SetPen

constructor TmyList.Create(oi:TTIPropertyGrid;buffer:TBitmap;pBg:Tbg);
begin
  liste:=TObjectlist.Create;
//  fbuffer:=TBitmap.Create;
//  fbuffer.Assign(buffer);
  fbuffer:=buffer;
  itemindex:=-1;
  bg:=pbg; fVt:=oi;
  selobject:=nil;
end;

procedure Tmylist.Clear;
begin

end;

procedure Tmylist.SetSelObj(value:Boolean);
var
  i:Integer;
begin
  for i:=0 to liste.Count-1 do begin
    TPaint2BasesObj(liste.Items[i]).Sel:=value;
  end;
//  itemindex:=-1;
end;

procedure Tmylist.UpdatetOI;
begin
  if (selobject <> NIL) and (fvt.TIObject <> NIL) then begin
    fvt.TIObject:=selobject;
    fvt.PropEditLookupRootChange;
    fvt.RefreshPropertyValues;
    fvt.Clear;

    writeln('test');
    fvt.Update;
    fvt.Invalidate;
    fvt.Refresh;

  end;

end;

end.

