unit upaint2main;

{$mode objfpc}{$H+}

interface

uses
  LCLIntf,  SysUtils, Classes, Graphics, Controls, uliste,Forms,
  Dialogs, ExtCtrls, StdCtrls,uPaint2Obj,RTTIGrids,inifiles,uPaint2Object,upaint2ObjBase;
  
type
  tonAddObj = procedure(obj:TPaint2BasesObj) of Object;
  TonChangeObj = procedure(Newobj:TPaint2BasesObj) of object;
  tOnSizeChange = procedure(NW,NH:integer) of object;
  tDeleteObj = procedure(index:Integer) of object;


  TMouseDown1 =  procedure(sender:TObject;Button: TMouseButton;Shift: TShiftState; X, Y: Integer) of object;
  TMouseMove1 =  procedure(Sender: TObject;Shift: TShiftState; X,Y: Integer) of object;
  TMouseUp1 = procedure(Sender: TObject;Button: TMouseButton; Shift:TShiftState; X,Y:Integer) of object;

  { TPaint2Main }


  TPaint2Main = class(TCustomControl)
  private
    buffer:TBitMap;
    fPen:TPen;
    fBrush:TBrush;
    fPanel:TPanel;
    function Getbrush: TBrush;
    function GetPen: TPen;
    function GetSize: TPoint2;
    procedure SetBrush(const AValue: TBrush);
    procedure SetPen(const AValue: TPen);
    procedure SetSize(const AValue: TPoint2);
    procedure ChangeBGSize(Newobj:TPaint2BasesObj);
  public
    liste:TmyList;
    onAddObj:tonAddObj;
    onChangeobj:TonChangeObj;
    onChangeSize:tOnSizeChange;
    onDeleteObj:tDeleteObj;
    isup:Boolean;
    bg:Tbg;
    ti,tc:Integer;
    buffer2,buffer3,buffer4:TBitmap;
    ox,oy,ow,oh:Integer;
    t:Boolean;
    mx,my,sx,sy:Integer;
    onMouseMove1:TMouseMove1;
    onMouseDown1:TMouseDown1;
    onMouseUp1:TMouseUp1;
    procedure MouseDown(Button:TMouseButton;Shift: TShiftState; X,Y: Integer);override;
    procedure MouseMove(Shift: TShiftState; X,Y: Integer);override;
    procedure MouseUp(Button: TMouseButton; Shift:TShiftState; X,Y:Integer);override;
    procedure PaintAllobj;

    procedure Clear;
    constructor Create(AOwner:TComponent);override;
    constructor Create(AOwner:TComponent;flistbox:TListBox;oi:TTIPropertyGrid;Panel:TPanel;w,h:Integer);
    destructor Destroy;override;
    procedure AddObj(toolindex,x,y,w,h:integer);
//    procedure DrawObj(t1:Boolean = false);
    procedure Flip;
    procedure DelSelObj;
    procedure LoadVorlage(FileName:TFileName;obj:TPaint2BasesObj);
    procedure SaveVorlage(FileName:TFileName;obj:TPaint2BasesObj);
    procedure LoadFromFile(FileName:TFileName);
    procedure Paint; override;
    procedure CopyToBuffer;
    procedure ClearBuffer2;
    procedure SetSizeAllBuffers(w,h:Integer);
  published
    property Size:TPoint2 read GetSize write SetSize;
    property Brush:TBrush read Getbrush write SetBrush;
    property Pen:TPen read GetPen write SetPen;
  end;
  
var
  paint2:TPaint2Main;

implementation

uses uPaint2Raster;
{ TPaint2Main }

procedure TPaint2Main.MouseDown(Button:TMouseButton;Shift: TShiftState; X,Y: Integer);
begin
  onMouseDown1(self,button,shift,x,y);
  inherited MouseDown(Button,Shift,X,Y);
  Invalidate;
  ox:=x;
  oy:=y;
  ClearBuffer2;
end;

procedure TPaint2Main.MouseMove(Shift: TShiftState; X,Y: Integer);
begin

   if ssright in shift then Tag:=random(200);
ow:=x;
  oh:=y;


   onMouseMove1(self,Shift,x,y);

   if shift <> [] then begin
    inherited MouseMove(Shift,X,Y);
    Invalidate;
   end;
   PaintAllobj;
end;

procedure TPaint2Main.MouseUp(Button: TMouseButton; Shift:TShiftState; X,Y:Integer);
begin

  onMouseUp1(self,Button,shift,x,y);
  isup:=True;
  inherited Mouseup(Button,Shift,X,Y);
  Invalidate;

end;

procedure TPaint2Main.ChangeBGSize(Newobj:TPaint2BasesObj);
begin
end;

//  fpanel.Width:=bg.size.x;
//  fpanel.Height:=bg.size.y;
//  bg.Name:='test1';
//  SetSize(pointTOTPoint2(bg.size.x,bg.size.y));

//end;

procedure TPaint2Main.Clear;
begin
//  Buffer2.Width:=1; Buffer2.Height:=1;
//  fbrush.Color:=clRed;
//  Buffer2.Width:=Width; Buffer2.Height:=Height;
end;

function TPaint2Main.GetSize: TPoint2;
var
  aValue:TPoint2;
begin
  aValue:=TPoint2.create;
  aValue.x:=buffer2.Width;
  aValue.y:=buffer2.Height;
  result:=aValue;
end; // GetSize

procedure TPaint2Main.SetSize(const AValue: TPoint2);
begin
//  buffer.Width:=avalue.x; buffer.Height:=avalue.y;

//  bg.Size.x:=buffer.Width-4;
//  bg.Size.y:=buffer.Height-4;
  SetSizeAllBuffers(AValue.x,AValue.y);
  if Assigned(onChangeSize) then onChangeSize(AValue.x,AValue.y)
end; // SetSize

function TPaint2Main.Getbrush: TBrush;
begin
  result:=fbrush;
end;

procedure TPaint2Main.SetBrush(const AValue: TBrush);
begin
  fbrush.Assign(AValue);

end;

function TPaint2Main.GetPen: TPen;
begin
  result:=fPen;
end;

procedure TPaint2Main.SetPen(const AValue: TPen);
begin
  fpen.Assign(avalue);
end;

constructor TPaint2Main.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  Buffer:=TBitmap.create; Buffer2:=TBitmap.create; Buffer3:=TBitmap.create;
  buffer4:=TBitmap.Create;

  bg:=Tbg.Create(buffer);
  bg.Typ:=Backgrund;
  bg.Brush.color:=clBlue;
  bg.Pen.Style:=psSolid;
  bg.Visible:=true;
  bg.Position:=pointTOTPoint2(0,0);
  bg.size:=pointTOTPoint2(0,0);
  bg.PointsModus:=0;
  bg.pointDrawDown:=2;
  bg.Raster:=TPaint2Raster.create;
  bg.Raster.rx:=16; bg.Raster.ry:=16;
  bg.Raster.onChangeValue:=@flip;

  liste:=TmyList.Create(nil,buffer,bg);
  liste.usrListBox:=nil;
  liste.bg:=bg;
  fPen:=TPen.Create;
  fPen.color:=clYellow;
  fBrush:=TBrush.Create;
  fBrush.Color:=clLime;
//  fpanel:=AOwner;
  ti:=0; tc:=30;
  paint2:=Self;
  liste.selobject:=bg;


end;

constructor TPaint2Main.Create(AOwner:TComponent;flistbox:TListBox;oi:TTIPropertyGrid;Panel: TPanel; w, h: Integer);
begin
  inherited Create(AOwner);

  Buffer:=TBitmap.create; Buffer2:=TBitmap.create; Buffer3:=TBitmap.create;
  buffer4:=TBitmap.Create;
  buffer2.Width:=w; buffer2.Height:=h;
  
  bg:=Tbg.Create(buffer);
  bg.Typ:=Backgrund;
  bg.Brush.color:=clBlue;
  bg.Pen.Style:=psSolid;
  bg.Visible:=true;
  bg.Position:=pointTOTPoint2(0,0);
  bg.size:=pointTOTPoint2(w-4,h-4);
  bg.PointsModus:=0;
  bg.pointDrawDown:=2;
  bg.Raster:=TPaint2Raster.create;
  bg.Raster.rx:=16; bg.Raster.ry:=16;
  bg.Raster.onChangeValue:=@flip;

  liste:=TmyList.Create(oi,buffer,bg);
  liste.usrListBox:=flistbox;
  liste.bg:=bg;
  fPen:=TPen.Create;
  fPen.color:=clYellow;
  fBrush:=TBrush.Create;
  fBrush.Color:=clLime;
  fpanel:=panel;
  ti:=0; tc:=30;
  paint2:=Self;
  liste.selobject:=bg;


//  Paint;
//  bg.onChangeobj:=@ChangeBGSize;

end; // Create

procedure TPaint2Main.AddObj(toolindex,x,y,w,h: integer);
var
  pobj:TPaint2Object;
begin
  pobj:=liste.AddObj(toolindex);
  if pobj <> NIL then begin
    if toolindex < 80 then begin
      with TPaint2BasesObj(pobj) do begin
        pointDrawDown:=-1;   pointDrawMove:=-1;

        Position:=pointTOTPoint2(x,y);
        Size:=pointTOTPoint2(w,h);
        if toolindex = alt_Line then
          PointsModus:=1
        else
          PointsModus:=0;

        typ:=toolindex;
        Name:=Name + IntTostr(liste.GetName(typ)+1);
        Brush.Color:=clLime;
        sel:=true;
        visible:=true;
        pointDrawDown:=2;
        Raster.rx:=16;         Raster.ry:=16;
        Raster.onChangeValue:=@Flip;
       if Assigned(onAddObj) then onAddObj(liste.selobject);
       if Assigned(onChangeobj) then onChangeobj(liste.selobject);
      end;
//      liste.selobject:=TPaint2BasesObj(pobj);
    end
    else begin
    liste.usrListBox.Items[liste.usrListBox.items.Count-1]:=liste.usrListBox.items[liste.usrListBox.items.Count-1] +IntTostr(liste.GetName(toolindex));
    end;

  end
  else
    WriteLN('Das Objekt: ' + IntTostr( toolindex) + #13#10'wird zur zeit noch nicht untersttzt !');

end; // AddObj

//procedure Tpaint2Main.DrawObj(t1:Boolean = false);
//var
//  i,sx,sy,px,py:integer;
//begin
//  paint;
{  clear;
  bg.Draw(buffer,false);
  bg.raster.Draw(bg.position.x,bg.position.y,bg.size.x,bg.size.y,buffer,bg.oldpen,bg.oldbrush);

  for i:=0 to liste.liste.Count-1 do begin
    with TPaint2BasesObj(liste.liste.Items[i]) do begin
      if Visible = True then begin
        if ((PointsModus = 0) and ((Sel = true) or (i = liste.itemindex))) then begin
          l.Canvas.Pen.Style:=psDash;
          if i = liste.itemindex then
            Buffer.Canvas.Pen.Color:=clLime
          else
            Buffer.Canvas.Pen.Color:=clYellow;
    //      if TPaint2Obj(objList.Items[i])  is TLine = false then
          Buffer.Canvas.brush.Style:=bsClear;
          if position.x < size.x  then
            px:=Position.x-((pen.Width div 2)+1)
          else
            px:=Position.x+((pen.Width div 2)+1);

          if position.y < size.y then
            py:=position.y-((pen.Width div 2)+1)
          else
            py:=position.y+((pen.Width div 2)+1);

          if position.X < size.X   then
            sx:=size.x+((pen.Width div 2)+1)
          else
            sx:=size.x-((pen.Width div 2)+1);

          if  position.Y < size.Y  then
            sy:=size.y+((pen.Width div 2)+1)
          else
            sy:=size.y-((pen.Width div 2)+1);
          Buffer.Canvas.Rectangle(px,py,sx,sy);
        end;
        Draw(buffer,i = liste.itemindex);

      end; // visible
    end;
    if i = liste.itemindex then liste.GetPaint2Obj(i).Draw(buffer,true);
    TPaint2BasesObj(liste.liste.Items[i]).Raster.Draw(TPaint2BasesObj(liste.liste.Items[i]).position.x,TPaint2BasesObj(liste.liste.Items[i]).position.y,TPaint2BasesObj(liste.liste.Items[i]).size.x,TPaint2BasesObj(liste.liste.Items[i]).size.y,buffer,TPaint2BasesObj(liste.liste.Items[i]).oldpen,TPaint2BasesObj(liste.liste.Items[i]).oldbrush);
  end;
  
  if t1 = false then
    flip
  else begin
    if ti >= tc then begin
      flip;
      ti:=0;
    end
    else
      inc(ti);

  end;       }
//end; // DrawObj

procedure Tpaint2Main.Flip;
begin
//  BitBlt(Canvas.Handle,0,0,buffer.Width,buffer.Height,buffer.canvas.Handle,0,0,Canvas.CopyMode);
end;

procedure Tpaint2Main.DelSelObj;
begin
  liste.DeleteObject(-2);
  Paint;
  if Assigned(onDeleteObj) then onDeleteObj(liste.itemindex);
  if Assigned(onChangeobj) then onChangeobj(liste.selobject);

end;

procedure Tpaint2Main.LoadVorlage(FileName:TFileName;obj:TPaint2BasesObj);
var
  Emty:TIniFile;
begin
  Emty:=TIniFile.Create(FileName);
  if obj <> nil then begin
    with Emty do begin
      obj.Brush.Color:=StringToColor(ReadString('obj','Brush.Color',''));
      obj.Brush.Style:=TBrushStyle(ReadInteger('obj','Brush.Style',0));

      obj.Pen.Color:=StringToColor(ReadString('obj','Pen.Color',''));
      obj.Pen.Style:=TPenStyle(ReadInteger('obj','Pen.Style',0));

      obj.Pen.Width:=ReadInteger('obj','Pen.Width',0);
    end;
  end;
  Emty.free;
end;

procedure Tpaint2Main.SaveVorlage(FileName:TFileName;obj:TPaint2BasesObj);
var
  Emty:TIniFile;
begin
  Emty:=TIniFile.Create(FileName);
  if obj <> nil then begin
    with Emty do begin
      WriteString('obj','Brush.Color',ColorToString(obj.Brush.Color));
      WriteInteger('obj','Brush.Style',integer(obj.Brush.Style));

      WriteString('obj','Pen.Color',ColorToString(obj.Pen.Color));
      WriteInteger('obj','Pen.Style',integer(obj.Pen.Style));
      WriteInteger('obj','Pen.Width',integer(obj.Pen.Width));

    end;
  end;
  Emty.free;
end;

procedure TPaint2Main.LoadFromFile(FileName:TFileName);
begin
   liste.LoadFromFile(Filename);
   paint;
end;

procedure TPaint2Main.Paint;
var
  r1:TRect;
  px1,py1,sx1,sy1:Integer;
begin
//  if liste.selobject = nil then begin
//     r1.left:=0; r1.top:=0; r1.Right:=Width; r1.Bottom:=Height;
//     buffer3.canvas.copyrect(r1,buffer.canvas,r1);
//     Canvas.Draw(0,0,Buffer3);
//  end;

//    Screen.Forms[0].caption:=;
   if isup = true then begin
     isup:=false;
     CopyToBuffer;
   end;

   r1.left:=0; r1.top:=0; r1.Right:=Width; r1.Bottom:=Height;
   buffer3.canvas.copyrect(r1,buffer.canvas,r1);

  if (t = false) and (liste.selobject <> NIL ) and (liste.selobject is Tbg = false) then begin
//    mx:=liste.selobject.position.x;
//    my:=liste.selobject.position.y;
//  sx:=liste.selobject.size.x;
//    sy:=liste.selobject.size.y;
    inherited Paint;
     // damit ich was zu sehen bekomme wird das komplete
     // buffer nach buffer3 kopiert(weil ich kann ja buffer nicht immer andern)
    with Buffer2.Canvas do begin
      px1:=liste.selobject.position.x-5;
      py1:=liste.selobject.position.y-5;
      sx1:=liste.selobject.Size.x+5;
      sy1:=liste.selobject.Size.y+5;


      Brush.style:=bsSolid;
      Brush.color:=clBlack;
      Pen.Style:=psSolid;
      Pen.color:=clYellow;

      FillRect(px1,py1,sx1,sy1);
      liste.selobject.Draw(buffer2,true);


      buffer3.canvas.copyrect(rect(px1,py1,sx1,sy1),buffer2.canvas,rect(px1,py1,sx1,sy1));
      // um es zu sehen wird der buffer komplet nach canvas(von form1 kopiert)
//      Buffer3.SaveToFile('/media/hda7/test.bmp');
     end;
  end;
  Canvas.Draw(0,0,Buffer3);
end;

destructor TPaint2Main.Destroy;
begin
  inherited Destroy;
  buffer.free;
  buffer2.free;
  buffer3.free;
  buffer4.free;
  liste.free;
end;

procedure TPaint2Main.CopyToBuffer;
var
  r1:TRect;
begin
  if (liste.selobject <> NIL) and (liste.selobject is TBG = false) then begin
    r1.left:=liste.selobject.position.x;    r1.top:=liste.selobject.position.y;
    r1.Right:=liste.selobject.size.x; r1.Bottom:=liste.selobject.size.y;

//  r1.left:=ox;    r1.top:=oy;
//  r1.Right:=ow; r1.Bottom:=oh;

    buffer.canvas.copyrect(r1,buffer2.canvas,r1);
//    buffer.savetofile('/media/hda7/test4.bmp');
  end;
end;

procedure TPaint2Main.PaintAllobj;
var
  i:Integer;
begin
   for i:=0 to liste.liste.count-1 do begin
      if i <> liste.itemindex then
      TPaint2BasesObj(liste.liste[i]).Draw(buffer,false);
    end;

end;

procedure TPaint2main.ClearBuffer2;
var
  r:Trect;
  i:Integer;
begin
//  r.left:=ox;
//  r.top:=oy;
//  r.Right:=ow;
//  r.Bottom:=oh;


  buffer.canvas.CopyRect(r,buffer4.canvas,r);

  if (liste.selobject <> NIL) and (liste.selobject is TBG = false) then begin

{    for i:=0 to liste.liste.count-1 do begin
      if TPaint2BasesObj(liste.liste[i]).Sel = true then begin
        r.left:=TPaint2BasesObj(liste.liste[i]).Position.x;
        r.top:=TPaint2BasesObj(liste.liste[i]).Position.y;
        r.Right:=TPaint2BasesObj(liste.liste[i]).size.x;
        r.Bottom:=TPaint2BasesObj(liste.liste[i]).size.y;
      
        buffer.canvas.CopyRect(r,buffer2.canvas,r);
      end;
    end;}

        r.left:=liste.selobject.Position.x-5;
        r.top:=liste.selobject.Position.y-5;
        r.Right:=liste.selobject.size.x+5;
        r.Bottom:=liste.selobject.size.y+5;


        buffer.canvas.CopyRect(r,buffer4.canvas,r);
   // for i:=0 to liste.liste.count-1 do begin
//      if i <> liste.itemindex then
//      TPaint2BasesObj(liste.liste[i]).Draw(buffer,false);
//    end;
  end;
end;

procedure TPaint2main.SetSizeAllBuffers(w,h:Integer);
var
  arect:Trect;
begin
  if Assigned(Buffer) then begin
    t:=true;
    Width:=w; Height:=h;
    bg.size:=pointTOTPoint2(w,h);
    Buffer4.Width:=w; Buffer4.Height:=h;

    arect.left:=0; aRect.top:=0; arect.Right:=buffer4.Width; arect.Bottom:=buffer4.Height;
    bg.Draw(buffer4,true);


    Buffer.Width:=w;Buffer.Height:=h; Buffer2.Width:=w;Buffer2.Height:=h;
    Buffer3.Width:=w;Buffer3.Height:=h;
    arect.left:=0; aRect.top:=0; arect.Bottom:=h; arect.Right:=w;



    buffer.canvas.FillRect(arect); buffer3.canvas.FillRect(arect); buffer2.canvas.FillRect(arect);

    arect.left:=0; aRect.top:=0; arect.Right:=w; arect.Bottom:=h;

    buffer.canvas.CopyRect(aRect,buffer4.canvas,aRect);
    mx:=0; my:=0; sx:=bg.size.x; sy:=bg.size.y;
    t:=false;
//    bg.Draw(buffer4,true);
  end;
end;
end.

